﻿using System;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

using System.Data;
using System.Configuration;
using System.Data.SqlClient;
using System.Collections.Generic;
using Razor_RadioButtonList.Models;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Razor_RadioButtonList.Pages
{

    public class IndexModel : PageModel
    {
        public List<FruitModel> Fruits { get; set; }

        public void OnGet()
        {
            //Populate Model from Database.
            this.Fruits = PopulateFruits();
        }

        public void OnPostSubmit(int fruit)
        {
            //Populate Model from Database.
            this.Fruits = PopulateFruits();

            //Fetch the ID and the TEXT value.
            string message = "Selected Fruit Id: " + fruit;
            message += "\\nFruit Name: " + this.Fruits.Find(p => p.FruitId == fruit).FruitName;

            //Set the value in ViewData.
            ViewData["Message"] = message;
        }

        private static List<FruitModel> PopulateFruits()
        {
            string constr = @"Data Source=.\SQL2019;Initial Catalog=AjaxSamples;Integrated Security=true";
            List<FruitModel> fruits = new List<FruitModel>();
            using (SqlConnection con = new SqlConnection(constr))
            {
                string query = "SELECT FruitName, FruitId FROM Fruits";
                using (SqlCommand cmd = new SqlCommand(query))
                {
                    cmd.Connection = con;
                    con.Open();
                    using (SqlDataReader sdr = cmd.ExecuteReader())
                    {
                        while (sdr.Read())
                        {
                            fruits.Add(new FruitModel
                            {
                                FruitName = sdr["FruitName"].ToString(),
                                FruitId = Convert.ToInt32(sdr["FruitId"])
                            });
                        }
                    }
                    con.Close();
                }
            }

            return fruits;
        }
    }
}